package org.gcube.informationsystem.utils;

import java.util.Set;
import java.util.UUID;

import org.junit.Assert;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class UUIDManagerTest {

	private static final Logger logger = LoggerFactory.getLogger(UUIDManagerTest.class);
	
	@Test
	public void testReservedUUID() {
		Set<UUID> allUUID = UUIDManager.getAllReservedUUID();
		logger.debug("Reserved UUIDs are {}", allUUID);
		
		Set<String> allUUIDAsString = UUIDManager.getAllReservedUUIDAsStrings();
		Assert.assertTrue(allUUID.size()==allUUIDAsString.size());
		Assert.assertTrue(allUUID.size()==16);
		Assert.assertTrue(allUUIDAsString.size()==16);
		for(UUID uuid : allUUID) {
			Assert.assertTrue(UUIDManager.isReservedUUID(uuid));
			Assert.assertTrue(UUIDManager.isReservedUUID(uuid.toString()));
		}
		
		for(String uuidString : allUUIDAsString) {
			Assert.assertTrue(UUIDManager.isReservedUUID(UUID.fromString(uuidString)));
			Assert.assertTrue(UUIDManager.isReservedUUID(uuidString));
		}
		
	}
}
